
//-----------------------------------------------------------------------------
// AVR ADC Defination
#define ADC_PRESCALE_DIV2                   1
#define ADC_PRESCALE_DIV4                   2
#define ADC_PRESCALE_DIV8                   3
#define ADC_PRESCALE_DIV16                  4
#define ADC_PRESCALE_DIV32                  5
#define ADC_PRESCALE_DIV64                  6
#define ADC_PRESCALE_DIV128                 7

#define ADC_ENABLE                          0x80
#define ADC_START_CONVERSION                0x40
#define ADC_FREE_RUNNING                    0x20
#define ADC_COMPLETE                        0x10
#define ADC_INT_ENABLE                      0x08

#define ADC_REF_VREF                        0
#define ADC_REF_AVCC                        0x40
#define ADC_REF_INTERNAL                    0xC0

#define adc_WaitForCoversion()				while(!(ADC_SR_REG & ADC_COMPLETE))
#define adc_GetData() 						((ADCH<<8) | ADCL)
#define adc_SetChannel(Ch)					(ADMUX = (Ch)&7)
#define adc_Run()							(ADC_SR_REG |= ADC_START_CONVERSION)



//------------------------------------------------------
//Atmega128 Serial Register
#ifdef _HAL_MEGA128_UART
#define ADC_SR_REG							ADCSR
#endif

//------------------------------------------------------
//Atmega16 Serial Register
#ifdef _HAL_MEGA8_UART
#define ADC_SR_REG							ADCSRA
#endif

//------------------------------------------------------
//Atmega8 Serial Register
#ifdef _HAL_MEGA8_UART
#define ADC_SR_REG							ADCSRA
#endif

//------------------------------------------------------------------------------
//ADC Initialize
void adc_hal_init(void)
{
	ADMUX = 0;
    ADC_SR_REG = ADC_ENABLE | ADC_PRESCALE_DIV32;
}
//------------------------------------------------------------------------------