#include "..\..\00_hal\glcd_hal1815.h"
//variable definition


unsigned char m_RamAddress=0;


void GlcdData(SINT Ch);

void glcd_delay(unsigned int Cnt);

void glcd_port_init(void)
{
	LCD_CS1INIT();
	LCD_RSINIT();
	
	LCD_DATINIT();
	LCD_CLKINIT();
	LCD_RSTINIT();
}

void glcd_data_out(SINT Data)
{
    SINT i,temp=0;
    	
    for(i=0;i<8;i++)
    {
        LCD_CLK0(); 

        temp=(Data>>(7-i))&0x01;
         
        if(temp)LCD_DAT1();
        else LCD_DAT0();

		LCD_CLK1();
     }	
}

void glcd_set_col(SINT col)
{         
	// Set Lcd Ram Col Address 
	m_RamAddress=col;
	
	LCD_RSOFF();             
	col=col/16;             // high bit 
	col&=0x0F;              // and
	col=col|16; 
	GlcdData(col);
	
	//send address low bit
	m_RamAddress&=0x0F;            
	GlcdData(m_RamAddress);
	LCD_RSON();
	m_RamAddress=0x80;
}

// Set Lcd Ram Page Address 
void glcd_set_page(SINT Page)
{     
	LCD_RSOFF();
	Page&=0x0F; 
	Page=Page+0xB0;        // #1011,0000b
	GlcdData(Page);
	LCD_RSON() ;
	m_RamAddress=0x80;
}

void glcd_clear(void)
{
	int i = 0, j = 0;
	
	while(i<8)
	{
		j=0;
		glcd_set_page(i);
		glcd_set_col(j);
	
		while(j<128)
		{
			GlcdData(0x00);
			j++;
		}
		i++;
	}
	
	glcd_set_page(0x00);
	glcd_set_col(0x00);
	
	LCD_RSON() ;
}


void glcd_init(void) 
{      
	glcd_port_init();
	
    LCD_RST0();
    glcd_delay(500);
    LCD_RST1();
    glcd_delay(500);
    	
	LCD_RSOFF();
	glcd_delay(100);
	
	GlcdData(0xE2);
   
	GlcdData(0x2F);       //00101,111B,X2,X1,X0           set power control register
	GlcdData(0x23);       //00100,010B,X2,X1,X0           set internal regulator resistot ratio
	GlcdData(0x40);       //01,000000B,X5,X4,X3,X2,X1,X0  set display line
	GlcdData(0xa6);       //1010011,0B,X0                 set Noramal/Reverse Display
	GlcdData(0xa0);       //1010000,1B,X0                 set segment re_map  (=1,mirror image,column131 mapped to Seg0)
	GlcdData(0xc8);       //1100,1,000B,1100,X3,***B      set com output scan direction (flip vertically)  
	GlcdData(0xa2);       //1010001,0B,X0                 set Lcd bias=0, 1/9bias
	GlcdData(0xaf);       //1010111,1B,X0                 set display on/off
	GlcdData(0x81);       //10000001B                     set contrast control register
	GlcdData(0x22);       //00111111B,X5,X4,X3,X2,X1,X0   (2Byte Command,contrast value)       
	LCD_RSON();
}

void glcd_display_image(unsigned char *pImage)
{

	int i = 0, j = 0;
	int index = 0;
	
	while(i<7)
	{
		j=0;
		glcd_set_page(i);
		glcd_set_col(j);
	
		while(j<128)
		{
			GlcdData(pImage[index++]);
			j++;
		}
		i++;
	}
}
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------
void GlcdSetYAddress(SINT yAddr)
{
	glcd_set_page(yAddr);
}

void GlcdSetXAddress(SINT xAddr)
{
	glcd_set_col(xAddr);
}

void GlcdSetAddress(SINT X, SINT yLine)
{
	// set addresses
	GlcdSetYAddress(yLine);
	GlcdSetXAddress(X);
}

void glcd_delay(unsigned int Cnt)
{
	unsigned int i =0, j = 0;
	
	for(j=0; j<Cnt; j++)
	{
		for(i=0; i<10; i++);
	}
}

void GlcdData(SINT Ch)
{
    LCD_CS1OFF();
     
	glcd_data_out(Ch);
     
    LCD_CS1ON();     
}

//void Lcd_Cmd(SINT Cmd)
//{

//}

//-----------------------------------------------------------------------------
