//=============================================================================
// Microcontroller Serial Ʈ  API Լ
// by (nexp76@naver.com)
// [serial.c]
//=============================================================================

/*

*/

#include "..\00_hal\serial_hal.h"
#include "serial.h"

#ifdef _UART0_ENABLE
//------------------------------------------------------------------------------
// Serial Prot0 Utility Fuction Routine
void U0_Init(unsigned char baud)
{
	U0_SetBaud(baud);
	
	u0_hal_init();
}

void U0_SetBaud(unsigned char baud)
{
	u0_baudrate(baud);
}

unsigned char U0_GetByte(void)
{
	u0_WaitForReceive();
	
	return u0_RxData();
}

void U0_PutByte(unsigned char Data)
{
	u0_WaitForSend();
	
	u0_TxData(Data);
}

void U0_PutBuf(unsigned char *str, unsigned char len)
{
	unsigned char i =0;
	
    for(i=0;i<len;i++)
    {
        U0_PutByte(*(str+i));
    }
}

void U0_PutStr(unsigned char *str)
{
    while(*str != 0)
    {
        U0_PutByte(*str);
        str++;
    }
}

#define	U0_IsGetByte()				u0_IsReceiveData()
/*
unsigned char U0_IsGetByte(void)
{
	return u0_IsReceiveData();
}*/
//------------------------------------------------------------------------------
#endif	//end UART0 ENABLE


#ifdef _UART1_ENABLE
//------------------------------------------------------------------------------
// Serial Prot1 Utility Fuction Routine
void U1_Init(void)
{
//	U0_SetBaud(BAUD_57600);
	
	u1_hal_init();
}

void U1_SetBaud(unsigned char baud)
{
	u1_baudrate(baud);
}

unsigned char U1_GetByte(void)
{
	u1_WaitForReceive();
	
	return u1_RxData();
}

void U1_PutByte(unsigned char Data)
{
	u1_WaitForSend();
	
	u1_TxData(Data);
}

void U1_PutBuf(unsigned char *str, unsigned char len)
{
	unsigned char i =0;
	
    for(i=0;i<len;i++)
    {
        U1_PutByte(*(str+i));
    }
}

void U1_PutStr(unsigned char *str)
{
    while(*str != 0)
    {
        U1_PutByte(*str);
        str++;
    }
}

unsigned char U1_IsReceiveData(void)
{
	return u1_IsReceiveData();
}
//------------------------------------------------------------------------------
#endif	//end _UART1_ENABLE
